Index: /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_GCC.env
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_GCC.env	(revision 1469)
+++ /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_GCC.env	(revision 1470)
@@ -1,6 +1,10 @@
 module unload netcdf
 module unload hdf5
+module unload boost
+module unload blitz
 module load netcdf/4.3.3.1_hdf5_parallel
 module load gnu/4.9.1
+module load boost
+module load blitz
 export OMPI_CC=gcc
 export OMPI_CXX=g++
Index: /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_GCC.path
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_GCC.path	(revision 1469)
+++ /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_GCC.path	(revision 1470)
@@ -11,4 +11,12 @@
 HDF5_LIB=""
 
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
 OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
Index: /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_PGI.env
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_PGI.env	(revision 1469)
+++ /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_PGI.env	(revision 1470)
@@ -1,9 +1,13 @@
-module unload netcdf
-module unload hdf5
 module load netcdf/4.3.3.1_hdf5_parallel
 #module unload intel
 module unload pgi
 module unload gnu
+module unload boost
+module unload blitz
 module load pgi/14.10
+module load boost
+module load blitz
+
+
 
 export OMPI_CC=pgcc
Index: /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_PGI.path
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_PGI.path	(revision 1469)
+++ /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE_PGI.path	(revision 1470)
@@ -11,4 +11,12 @@
 HDF5_LIB=""
 
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
 OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
Index: /XIOS/trunk/arch/arch-X64_CURIE_GCC.env
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_GCC.env	(revision 1469)
+++ /XIOS/trunk/arch/arch-X64_CURIE_GCC.env	(revision 1470)
@@ -1,6 +1,10 @@
 module unload netcdf
 module unload hdf5
+module unload boost
+module unload blitz
 module load netcdf/4.3.3.1_hdf5_parallel
 module load gnu/4.9.1
+module load boost
+module load blitz
 export OMPI_CC=gcc
 export OMPI_CXX=g++
Index: /XIOS/trunk/arch/arch-X64_CURIE_GCC.path
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_GCC.path	(revision 1469)
+++ /XIOS/trunk/arch/arch-X64_CURIE_GCC.path	(revision 1470)
@@ -11,4 +11,12 @@
 HDF5_LIB=""
 
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
 OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
Index: /XIOS/trunk/arch/arch-X64_CURIE_PGI.env
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_PGI.env	(revision 1469)
+++ /XIOS/trunk/arch/arch-X64_CURIE_PGI.env	(revision 1470)
@@ -1,9 +1,13 @@
-module unload netcdf
-module unload hdf5
 module load netcdf/4.3.3.1_hdf5_parallel
 #module unload intel
 module unload pgi
 module unload gnu
+module unload boost
+module unload blitz
 module load pgi/14.10
+module load boost
+module load blitz
+
+
 
 export OMPI_CC=pgcc
Index: /XIOS/trunk/arch/arch-X64_CURIE_PGI.path
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_PGI.path	(revision 1469)
+++ /XIOS/trunk/arch/arch-X64_CURIE_PGI.path	(revision 1470)
@@ -11,4 +11,12 @@
 HDF5_LIB=""
 
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
 OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"