Index: XIOS/dev/XIOS_DEV_CMIP6/src/interface/fortran_attr/ifilegroup_attr.F90
===================================================================
--- XIOS/dev/XIOS_DEV_CMIP6/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 1211)
+++ XIOS/dev/XIOS_DEV_CMIP6/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 1492)
@@ -12,7 +12,8 @@
 
   SUBROUTINE xios(set_filegroup_attr)  &
-    ( filegroup_id, append, compression_level, convention, convention_str, cyclic, description, enabled  &
-    , format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access  &
-    , record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    ( filegroup_id, append, comment, compression_level, convention, convention_str, cyclic, description  &
+    , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
+    , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+    , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
     , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
@@ -22,4 +23,5 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: append
       LOGICAL (KIND=C_BOOL) :: append_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: comment
       INTEGER  , OPTIONAL, INTENT(IN) :: compression_level
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: convention
@@ -39,7 +41,12 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: output_level
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: par_access
+      LOGICAL  , OPTIONAL, INTENT(IN) :: read_metadata_par
+      LOGICAL (KIND=C_BOOL) :: read_metadata_par_tmp
       INTEGER  , OPTIONAL, INTENT(IN) :: record_offset
+      TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: split_end_offset
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: split_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_last_date
+      TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: split_start_offset
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: sync_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
@@ -57,18 +64,18 @@
       (filegroup_id,filegroup_hdl)
       CALL xios(set_filegroup_attr_hdl_)   &
-      ( filegroup_hdl, append, compression_level, convention, convention_str, cyclic, description  &
+      ( filegroup_hdl, append, comment, compression_level, convention, convention_str, cyclic, description  &
       , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
-      , par_access, record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name  &
-      , time_stamp_format, time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name  &
-       )
+      , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+      , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(set_filegroup_attr)
 
   SUBROUTINE xios(set_filegroup_attr_hdl)  &
-    ( filegroup_hdl, append, compression_level, convention, convention_str, cyclic, description  &
+    ( filegroup_hdl, append, comment, compression_level, convention, convention_str, cyclic, description  &
     , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
-    , par_access, record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name  &
-    , time_stamp_format, time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name  &
-     )
+    , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+    , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
     IMPLICIT NONE
@@ -76,4 +83,5 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: append
       LOGICAL (KIND=C_BOOL) :: append_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: comment
       INTEGER  , OPTIONAL, INTENT(IN) :: compression_level
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: convention
@@ -93,7 +101,12 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: output_level
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: par_access
+      LOGICAL  , OPTIONAL, INTENT(IN) :: read_metadata_par
+      LOGICAL (KIND=C_BOOL) :: read_metadata_par_tmp
       INTEGER  , OPTIONAL, INTENT(IN) :: record_offset
+      TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: split_end_offset
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: split_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_last_date
+      TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: split_start_offset
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: sync_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
@@ -109,16 +122,17 @@
 
       CALL xios(set_filegroup_attr_hdl_)  &
-      ( filegroup_hdl, append, compression_level, convention, convention_str, cyclic, description  &
+      ( filegroup_hdl, append, comment, compression_level, convention, convention_str, cyclic, description  &
       , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
-      , par_access, record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name  &
-      , time_stamp_format, time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name  &
-       )
+      , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+      , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(set_filegroup_attr_hdl)
 
   SUBROUTINE xios(set_filegroup_attr_hdl_)   &
-    ( filegroup_hdl, append_, compression_level_, convention_, convention_str_, cyclic_, description_  &
-    , enabled_, format_, group_ref_, min_digits_, mode_, name_, name_suffix_, output_freq_, output_level_  &
-    , par_access_, record_offset_, split_freq_, split_freq_format_, sync_freq_, time_counter_, time_counter_name_  &
+    ( filegroup_hdl, append_, comment_, compression_level_, convention_, convention_str_, cyclic_  &
+    , description_, enabled_, format_, group_ref_, min_digits_, mode_, name_, name_suffix_, output_freq_  &
+    , output_level_, par_access_, read_metadata_par_, record_offset_, split_end_offset_, split_freq_  &
+    , split_freq_format_, split_last_date_, split_start_offset_, sync_freq_, time_counter_, time_counter_name_  &
     , time_stamp_format_, time_stamp_name_, time_units_, timeseries_, ts_prefix_, type_, uuid_format_  &
     , uuid_name_ )
@@ -128,4 +142,5 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: append_
       LOGICAL (KIND=C_BOOL) :: append__tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: comment_
       INTEGER  , OPTIONAL, INTENT(IN) :: compression_level_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: convention_
@@ -145,7 +160,12 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: output_level_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: par_access_
+      LOGICAL  , OPTIONAL, INTENT(IN) :: read_metadata_par_
+      LOGICAL (KIND=C_BOOL) :: read_metadata_par__tmp
       INTEGER  , OPTIONAL, INTENT(IN) :: record_offset_
+      TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: split_end_offset_
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: split_freq_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_last_date_
+      TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: split_start_offset_
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: sync_freq_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter_
@@ -166,4 +186,9 @@
       ENDIF
 
+      IF (PRESENT(comment_)) THEN
+        CALL cxios_set_filegroup_comment &
+      (filegroup_hdl%daddr, comment_, len(comment_))
+      ENDIF
+
       IF (PRESENT(compression_level_)) THEN
         CALL cxios_set_filegroup_compression_level &
@@ -243,4 +268,10 @@
       ENDIF
 
+      IF (PRESENT(read_metadata_par_)) THEN
+        read_metadata_par__tmp = read_metadata_par_
+        CALL cxios_set_filegroup_read_metadata_par &
+      (filegroup_hdl%daddr, read_metadata_par__tmp)
+      ENDIF
+
       IF (PRESENT(record_offset_)) THEN
         CALL cxios_set_filegroup_record_offset &
@@ -248,4 +279,9 @@
       ENDIF
 
+      IF (PRESENT(split_end_offset_)) THEN
+        CALL cxios_set_filegroup_split_end_offset &
+      (filegroup_hdl%daddr, split_end_offset_)
+      ENDIF
+
       IF (PRESENT(split_freq_)) THEN
         CALL cxios_set_filegroup_split_freq &
@@ -258,4 +294,14 @@
       ENDIF
 
+      IF (PRESENT(split_last_date_)) THEN
+        CALL cxios_set_filegroup_split_last_date &
+      (filegroup_hdl%daddr, split_last_date_, len(split_last_date_))
+      ENDIF
+
+      IF (PRESENT(split_start_offset_)) THEN
+        CALL cxios_set_filegroup_split_start_offset &
+      (filegroup_hdl%daddr, split_start_offset_)
+      ENDIF
+
       IF (PRESENT(sync_freq_)) THEN
         CALL cxios_set_filegroup_sync_freq &
@@ -316,7 +362,8 @@
 
   SUBROUTINE xios(get_filegroup_attr)  &
-    ( filegroup_id, append, compression_level, convention, convention_str, cyclic, description, enabled  &
-    , format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access  &
-    , record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    ( filegroup_id, append, comment, compression_level, convention, convention_str, cyclic, description  &
+    , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
+    , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+    , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
     , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
@@ -326,4 +373,5 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: append
       LOGICAL (KIND=C_BOOL) :: append_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: comment
       INTEGER  , OPTIONAL, INTENT(OUT) :: compression_level
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: convention
@@ -343,7 +391,12 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: output_level
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: par_access
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: read_metadata_par
+      LOGICAL (KIND=C_BOOL) :: read_metadata_par_tmp
       INTEGER  , OPTIONAL, INTENT(OUT) :: record_offset
+      TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: split_end_offset
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: split_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_last_date
+      TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: split_start_offset
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: sync_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
@@ -361,18 +414,18 @@
       (filegroup_id,filegroup_hdl)
       CALL xios(get_filegroup_attr_hdl_)   &
-      ( filegroup_hdl, append, compression_level, convention, convention_str, cyclic, description  &
+      ( filegroup_hdl, append, comment, compression_level, convention, convention_str, cyclic, description  &
       , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
-      , par_access, record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name  &
-      , time_stamp_format, time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name  &
-       )
+      , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+      , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(get_filegroup_attr)
 
   SUBROUTINE xios(get_filegroup_attr_hdl)  &
-    ( filegroup_hdl, append, compression_level, convention, convention_str, cyclic, description  &
+    ( filegroup_hdl, append, comment, compression_level, convention, convention_str, cyclic, description  &
     , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
-    , par_access, record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name  &
-    , time_stamp_format, time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name  &
-     )
+    , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+    , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
     IMPLICIT NONE
@@ -380,4 +433,5 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: append
       LOGICAL (KIND=C_BOOL) :: append_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: comment
       INTEGER  , OPTIONAL, INTENT(OUT) :: compression_level
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: convention
@@ -397,7 +451,12 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: output_level
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: par_access
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: read_metadata_par
+      LOGICAL (KIND=C_BOOL) :: read_metadata_par_tmp
       INTEGER  , OPTIONAL, INTENT(OUT) :: record_offset
+      TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: split_end_offset
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: split_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_last_date
+      TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: split_start_offset
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: sync_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
@@ -413,16 +472,17 @@
 
       CALL xios(get_filegroup_attr_hdl_)  &
-      ( filegroup_hdl, append, compression_level, convention, convention_str, cyclic, description  &
+      ( filegroup_hdl, append, comment, compression_level, convention, convention_str, cyclic, description  &
       , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
-      , par_access, record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name  &
-      , time_stamp_format, time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name  &
-       )
+      , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+      , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(get_filegroup_attr_hdl)
 
   SUBROUTINE xios(get_filegroup_attr_hdl_)   &
-    ( filegroup_hdl, append_, compression_level_, convention_, convention_str_, cyclic_, description_  &
-    , enabled_, format_, group_ref_, min_digits_, mode_, name_, name_suffix_, output_freq_, output_level_  &
-    , par_access_, record_offset_, split_freq_, split_freq_format_, sync_freq_, time_counter_, time_counter_name_  &
+    ( filegroup_hdl, append_, comment_, compression_level_, convention_, convention_str_, cyclic_  &
+    , description_, enabled_, format_, group_ref_, min_digits_, mode_, name_, name_suffix_, output_freq_  &
+    , output_level_, par_access_, read_metadata_par_, record_offset_, split_end_offset_, split_freq_  &
+    , split_freq_format_, split_last_date_, split_start_offset_, sync_freq_, time_counter_, time_counter_name_  &
     , time_stamp_format_, time_stamp_name_, time_units_, timeseries_, ts_prefix_, type_, uuid_format_  &
     , uuid_name_ )
@@ -432,4 +492,5 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: append_
       LOGICAL (KIND=C_BOOL) :: append__tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: comment_
       INTEGER  , OPTIONAL, INTENT(OUT) :: compression_level_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: convention_
@@ -449,7 +510,12 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: output_level_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: par_access_
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: read_metadata_par_
+      LOGICAL (KIND=C_BOOL) :: read_metadata_par__tmp
       INTEGER  , OPTIONAL, INTENT(OUT) :: record_offset_
+      TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: split_end_offset_
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: split_freq_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_last_date_
+      TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: split_start_offset_
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: sync_freq_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter_
@@ -470,4 +536,9 @@
       ENDIF
 
+      IF (PRESENT(comment_)) THEN
+        CALL cxios_get_filegroup_comment &
+      (filegroup_hdl%daddr, comment_, len(comment_))
+      ENDIF
+
       IF (PRESENT(compression_level_)) THEN
         CALL cxios_get_filegroup_compression_level &
@@ -547,4 +618,10 @@
       ENDIF
 
+      IF (PRESENT(read_metadata_par_)) THEN
+        CALL cxios_get_filegroup_read_metadata_par &
+      (filegroup_hdl%daddr, read_metadata_par__tmp)
+        read_metadata_par_ = read_metadata_par__tmp
+      ENDIF
+
       IF (PRESENT(record_offset_)) THEN
         CALL cxios_get_filegroup_record_offset &
@@ -552,4 +629,9 @@
       ENDIF
 
+      IF (PRESENT(split_end_offset_)) THEN
+        CALL cxios_get_filegroup_split_end_offset &
+      (filegroup_hdl%daddr, split_end_offset_)
+      ENDIF
+
       IF (PRESENT(split_freq_)) THEN
         CALL cxios_get_filegroup_split_freq &
@@ -562,4 +644,14 @@
       ENDIF
 
+      IF (PRESENT(split_last_date_)) THEN
+        CALL cxios_get_filegroup_split_last_date &
+      (filegroup_hdl%daddr, split_last_date_, len(split_last_date_))
+      ENDIF
+
+      IF (PRESENT(split_start_offset_)) THEN
+        CALL cxios_get_filegroup_split_start_offset &
+      (filegroup_hdl%daddr, split_start_offset_)
+      ENDIF
+
       IF (PRESENT(sync_freq_)) THEN
         CALL cxios_get_filegroup_sync_freq &
@@ -620,7 +712,8 @@
 
   SUBROUTINE xios(is_defined_filegroup_attr)  &
-    ( filegroup_id, append, compression_level, convention, convention_str, cyclic, description, enabled  &
-    , format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access  &
-    , record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    ( filegroup_id, append, comment, compression_level, convention, convention_str, cyclic, description  &
+    , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
+    , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+    , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
     , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
@@ -630,4 +723,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: append
       LOGICAL(KIND=C_BOOL) :: append_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: comment
+      LOGICAL(KIND=C_BOOL) :: comment_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: compression_level
       LOGICAL(KIND=C_BOOL) :: compression_level_tmp
@@ -660,10 +755,18 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: par_access
       LOGICAL(KIND=C_BOOL) :: par_access_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: read_metadata_par
+      LOGICAL(KIND=C_BOOL) :: read_metadata_par_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: record_offset
       LOGICAL(KIND=C_BOOL) :: record_offset_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_end_offset
+      LOGICAL(KIND=C_BOOL) :: split_end_offset_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq
       LOGICAL(KIND=C_BOOL) :: split_freq_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq_format
       LOGICAL(KIND=C_BOOL) :: split_freq_format_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_last_date
+      LOGICAL(KIND=C_BOOL) :: split_last_date_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_start_offset
+      LOGICAL(KIND=C_BOOL) :: split_start_offset_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
       LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
@@ -692,18 +795,18 @@
       (filegroup_id,filegroup_hdl)
       CALL xios(is_defined_filegroup_attr_hdl_)   &
-      ( filegroup_hdl, append, compression_level, convention, convention_str, cyclic, description  &
+      ( filegroup_hdl, append, comment, compression_level, convention, convention_str, cyclic, description  &
       , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
-      , par_access, record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name  &
-      , time_stamp_format, time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name  &
-       )
+      , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+      , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(is_defined_filegroup_attr)
 
   SUBROUTINE xios(is_defined_filegroup_attr_hdl)  &
-    ( filegroup_hdl, append, compression_level, convention, convention_str, cyclic, description  &
+    ( filegroup_hdl, append, comment, compression_level, convention, convention_str, cyclic, description  &
     , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
-    , par_access, record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name  &
-    , time_stamp_format, time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name  &
-     )
+    , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+    , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
     IMPLICIT NONE
@@ -711,4 +814,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: append
       LOGICAL(KIND=C_BOOL) :: append_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: comment
+      LOGICAL(KIND=C_BOOL) :: comment_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: compression_level
       LOGICAL(KIND=C_BOOL) :: compression_level_tmp
@@ -741,10 +846,18 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: par_access
       LOGICAL(KIND=C_BOOL) :: par_access_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: read_metadata_par
+      LOGICAL(KIND=C_BOOL) :: read_metadata_par_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: record_offset
       LOGICAL(KIND=C_BOOL) :: record_offset_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_end_offset
+      LOGICAL(KIND=C_BOOL) :: split_end_offset_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq
       LOGICAL(KIND=C_BOOL) :: split_freq_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq_format
       LOGICAL(KIND=C_BOOL) :: split_freq_format_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_last_date
+      LOGICAL(KIND=C_BOOL) :: split_last_date_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_start_offset
+      LOGICAL(KIND=C_BOOL) :: split_start_offset_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
       LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
@@ -771,16 +884,17 @@
 
       CALL xios(is_defined_filegroup_attr_hdl_)  &
-      ( filegroup_hdl, append, compression_level, convention, convention_str, cyclic, description  &
+      ( filegroup_hdl, append, comment, compression_level, convention, convention_str, cyclic, description  &
       , enabled, format, group_ref, min_digits, mode, name, name_suffix, output_freq, output_level  &
-      , par_access, record_offset, split_freq, split_freq_format, sync_freq, time_counter, time_counter_name  &
-      , time_stamp_format, time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name  &
-       )
+      , par_access, read_metadata_par, record_offset, split_end_offset, split_freq, split_freq_format  &
+      , split_last_date, split_start_offset, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(is_defined_filegroup_attr_hdl)
 
   SUBROUTINE xios(is_defined_filegroup_attr_hdl_)   &
-    ( filegroup_hdl, append_, compression_level_, convention_, convention_str_, cyclic_, description_  &
-    , enabled_, format_, group_ref_, min_digits_, mode_, name_, name_suffix_, output_freq_, output_level_  &
-    , par_access_, record_offset_, split_freq_, split_freq_format_, sync_freq_, time_counter_, time_counter_name_  &
+    ( filegroup_hdl, append_, comment_, compression_level_, convention_, convention_str_, cyclic_  &
+    , description_, enabled_, format_, group_ref_, min_digits_, mode_, name_, name_suffix_, output_freq_  &
+    , output_level_, par_access_, read_metadata_par_, record_offset_, split_end_offset_, split_freq_  &
+    , split_freq_format_, split_last_date_, split_start_offset_, sync_freq_, time_counter_, time_counter_name_  &
     , time_stamp_format_, time_stamp_name_, time_units_, timeseries_, ts_prefix_, type_, uuid_format_  &
     , uuid_name_ )
@@ -790,4 +904,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: append_
       LOGICAL(KIND=C_BOOL) :: append__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: comment_
+      LOGICAL(KIND=C_BOOL) :: comment__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: compression_level_
       LOGICAL(KIND=C_BOOL) :: compression_level__tmp
@@ -820,10 +936,18 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: par_access_
       LOGICAL(KIND=C_BOOL) :: par_access__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: read_metadata_par_
+      LOGICAL(KIND=C_BOOL) :: read_metadata_par__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: record_offset_
       LOGICAL(KIND=C_BOOL) :: record_offset__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_end_offset_
+      LOGICAL(KIND=C_BOOL) :: split_end_offset__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq_
       LOGICAL(KIND=C_BOOL) :: split_freq__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq_format_
       LOGICAL(KIND=C_BOOL) :: split_freq_format__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_last_date_
+      LOGICAL(KIND=C_BOOL) :: split_last_date__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_start_offset_
+      LOGICAL(KIND=C_BOOL) :: split_start_offset__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq_
       LOGICAL(KIND=C_BOOL) :: sync_freq__tmp
@@ -855,4 +979,10 @@
       ENDIF
 
+      IF (PRESENT(comment_)) THEN
+        comment__tmp = cxios_is_defined_filegroup_comment &
+      (filegroup_hdl%daddr)
+        comment_ = comment__tmp
+      ENDIF
+
       IF (PRESENT(compression_level_)) THEN
         compression_level__tmp = cxios_is_defined_filegroup_compression_level &
@@ -945,4 +1075,10 @@
       ENDIF
 
+      IF (PRESENT(read_metadata_par_)) THEN
+        read_metadata_par__tmp = cxios_is_defined_filegroup_read_metadata_par &
+      (filegroup_hdl%daddr)
+        read_metadata_par_ = read_metadata_par__tmp
+      ENDIF
+
       IF (PRESENT(record_offset_)) THEN
         record_offset__tmp = cxios_is_defined_filegroup_record_offset &
@@ -951,4 +1087,10 @@
       ENDIF
 
+      IF (PRESENT(split_end_offset_)) THEN
+        split_end_offset__tmp = cxios_is_defined_filegroup_split_end_offset &
+      (filegroup_hdl%daddr)
+        split_end_offset_ = split_end_offset__tmp
+      ENDIF
+
       IF (PRESENT(split_freq_)) THEN
         split_freq__tmp = cxios_is_defined_filegroup_split_freq &
@@ -963,4 +1105,16 @@
       ENDIF
 
+      IF (PRESENT(split_last_date_)) THEN
+        split_last_date__tmp = cxios_is_defined_filegroup_split_last_date &
+      (filegroup_hdl%daddr)
+        split_last_date_ = split_last_date__tmp
+      ENDIF
+
+      IF (PRESENT(split_start_offset_)) THEN
+        split_start_offset__tmp = cxios_is_defined_filegroup_split_start_offset &
+      (filegroup_hdl%daddr)
+        split_start_offset_ = split_start_offset__tmp
+      ENDIF
+
       IF (PRESENT(sync_freq_)) THEN
         sync_freq__tmp = cxios_is_defined_filegroup_sync_freq &