Index: /XIOS/dev/branch_openmp/extern/ep_dev/ep_dup.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/ep_dev/ep_dup.cpp	(revision 1511)
+++ /XIOS/dev/branch_openmp/extern/ep_dev/ep_dup.cpp	(revision 1512)
@@ -90,5 +90,5 @@
         out_comm[i]->is_intercomm = true;
 
-        out_comm[i]->ep_comm_ptr->intercomm->intercomm_rank_map = new RANK_MAP;
+        out_comm[i]->ep_comm_ptr->intercomm->inter_rank_map = new RANK_MAP;
         out_comm[i]->ep_comm_ptr->intercomm->local_rank_map = new RANK_MAP;
         out_comm[i]->ep_comm_ptr->intercomm->remote_rank_map = new RANK_MAP;
@@ -96,5 +96,5 @@
         int map_size = 0;
         map_size = comm->ep_comm_ptr->comm_list[i]->ep_comm_ptr->intercomm->intercomm_rank_map->size();
-        out_comm[i]->ep_comm_ptr->intercomm->intercomm_rank_map->resize(map_size);
+        out_comm[i]->ep_comm_ptr->intercomm->inter_rank_map->resize(map_size);
         for(int ii=0; ii<map_size; ii++)
           out_comm[i]->ep_comm_ptr->intercomm->intercomm_rank_map->at(ii) = comm->ep_comm_ptr->comm_list[i]->ep_comm_ptr->intercomm->intercomm_rank_map->at(ii);
@@ -115,5 +115,5 @@
         //out_comm[i]->ep_comm_ptr->intercomm->remote_rank_map = comm->ep_comm_ptr->comm_list[i]->ep_comm_ptr->intercomm->remote_rank_map;
 
-        out_comm[i]->ep_comm_ptr->intercomm->local_comm = comm->ep_comm_ptr->comm_list[i]->ep_comm_ptr->intercomm->local_comm;        
+        //out_comm[i]->ep_comm_ptr->intercomm->local_comm = comm->ep_comm_ptr->comm_list[i]->ep_comm_ptr->intercomm->local_comm;        
         out_comm[i]->ep_comm_ptr->intercomm->intercomm_tag = comm->ep_comm_ptr->comm_list[i]->ep_comm_ptr->intercomm->intercomm_tag;
 
Index: /XIOS/dev/branch_openmp/extern/ep_dev/ep_intercomm.hpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/ep_dev/ep_intercomm.hpp	(revision 1511)
+++ /XIOS/dev/branch_openmp/extern/ep_dev/ep_intercomm.hpp	(revision 1512)
@@ -19,4 +19,5 @@
 
     INTERCOMM_RANK_MAP *intercomm_rank_map;
+    RANK_MAP *inter_rank_map;
     RANK_MAP *local_rank_map;
     RANK_MAP *remote_rank_map;
@@ -26,5 +27,5 @@
 
 
-    ep_comm *local_comm;
+    //ep_comm *local_comm;
     int intercomm_tag;
 
Index: /XIOS/dev/branch_openmp/extern/ep_dev/ep_intercomm_world.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/ep_dev/ep_intercomm_world.cpp	(revision 1511)
+++ /XIOS/dev/branch_openmp/extern/ep_dev/ep_intercomm_world.cpp	(revision 1512)
@@ -472,11 +472,11 @@
 
 
-    (*newintercomm)->ep_comm_ptr->intercomm->local_rank_map = new RANK_MAP;
-    (*newintercomm)->ep_comm_ptr->intercomm->local_rank_map->resize(local_ep_size);
-
-    MPI_Allgather(my_rank_map_elem, 2, MPI_INT, (*newintercomm)->ep_comm_ptr->intercomm->local_rank_map->data(), 2, MPI_INT, local_comm);
+    //(*newintercomm)->ep_comm_ptr->intercomm->local_rank_map = new RANK_MAP;
+    //(*newintercomm)->ep_comm_ptr->intercomm->local_rank_map->resize(local_ep_size);
+
+    //MPI_Allgather(my_rank_map_elem, 2, MPI_INT, (*newintercomm)->ep_comm_ptr->intercomm->local_rank_map->data(), 2, MPI_INT, local_comm);
    
-    (*newintercomm)->ep_comm_ptr->intercomm->remote_rank_map = new RANK_MAP;
-    (*newintercomm)->ep_comm_ptr->intercomm->remote_rank_map->resize(remote_ep_size);
+    //(*newintercomm)->ep_comm_ptr->intercomm->remote_rank_map = new RANK_MAP;
+    //(*newintercomm)->ep_comm_ptr->intercomm->remote_rank_map->resize(remote_ep_size);
 
     int local_intercomm_size = intercomm_ep_size;
@@ -488,7 +488,7 @@
       ::MPI_Status status;
 
-      ::MPI_Send((*newintercomm)->ep_comm_ptr->intercomm->local_rank_map->data(), 2*local_ep_size, to_mpi_type(MPI_INT), mpi_remote_leader, tag, peer_comm);
-
-      ::MPI_Recv((*newintercomm)->ep_comm_ptr->intercomm->remote_rank_map->data(), 2*remote_ep_size, to_mpi_type(MPI_INT), mpi_remote_leader, tag, peer_comm, &status);
+      //::MPI_Send((*newintercomm)->ep_comm_ptr->intercomm->local_rank_map->data(), 2*local_ep_size, to_mpi_type(MPI_INT), mpi_remote_leader, tag, peer_comm);
+
+      //::MPI_Recv((*newintercomm)->ep_comm_ptr->intercomm->remote_rank_map->data(), 2*remote_ep_size, to_mpi_type(MPI_INT), mpi_remote_leader, tag, peer_comm, &status);
 
       ::MPI_Send(&local_intercomm_size, 1, to_mpi_type(MPI_INT), mpi_remote_leader, tag, peer_comm);
@@ -497,14 +497,14 @@
     }
 
-    MPI_Bcast((*newintercomm)->ep_comm_ptr->intercomm->remote_rank_map->data(), 2*remote_ep_size, MPI_INT, local_leader, local_comm);
+    //MPI_Bcast((*newintercomm)->ep_comm_ptr->intercomm->remote_rank_map->data(), 2*remote_ep_size, MPI_INT, local_leader, local_comm);
     MPI_Bcast(&remote_intercomm_size, 1, MPI_INT, 0, *newintercomm);
 
 
-    (*newintercomm)->ep_comm_ptr->intercomm->intercomm_rank_map = new RANK_MAP;
-    (*newintercomm)->ep_comm_ptr->intercomm->intercomm_rank_map->resize(remote_intercomm_size);
-
-    (*newintercomm)->ep_comm_ptr->intercomm->size_rank_info[0] = local_comm->ep_comm_ptr->size_rank_info[0];
-    (*newintercomm)->ep_comm_ptr->intercomm->size_rank_info[1] = local_comm->ep_comm_ptr->size_rank_info[1];
-    (*newintercomm)->ep_comm_ptr->intercomm->size_rank_info[2] = local_comm->ep_comm_ptr->size_rank_info[2];
+    //(*newintercomm)->ep_comm_ptr->intercomm->intercomm_rank_map = new RANK_MAP;
+    //(*newintercomm)->ep_comm_ptr->intercomm->intercomm_rank_map->resize(remote_intercomm_size);
+
+    //(*newintercomm)->ep_comm_ptr->intercomm->size_rank_info[0] = local_comm->ep_comm_ptr->size_rank_info[0];
+    //(*newintercomm)->ep_comm_ptr->intercomm->size_rank_info[1] = local_comm->ep_comm_ptr->size_rank_info[1];
+    //(*newintercomm)->ep_comm_ptr->intercomm->size_rank_info[2] = local_comm->ep_comm_ptr->size_rank_info[2];
 
 
@@ -529,11 +529,11 @@
       for(ii=0; ii<vec2map.size(); ii++)
       {
-        (*newintercomm)->ep_comm_ptr->intercomm->intercomm_rank_map->at(vec2map[ii].first) = make_pair(vec2map[ii].second.first, vec2map[ii].second.second);
-      }
-    }
-
-    MPI_Bcast((*newintercomm)->ep_comm_ptr->intercomm->intercomm_rank_map->data(), 2*remote_intercomm_size, MPI_INT, 0, *newintercomm);
-
-    (*newintercomm)->ep_comm_ptr->intercomm->local_comm = (local_comm->ep_comm_ptr->comm_list[ep_rank_loc]);
+        //(*newintercomm)->ep_comm_ptr->intercomm->intercomm_rank_map->at(vec2map[ii].first) = make_pair(vec2map[ii].second.first, vec2map[ii].second.second);
+      }
+    }
+
+    //MPI_Bcast((*newintercomm)->ep_comm_ptr->intercomm->intercomm_rank_map->data(), 2*remote_intercomm_size, MPI_INT, 0, *newintercomm);
+
+    //(*newintercomm)->ep_comm_ptr->intercomm->local_comm = (local_comm->ep_comm_ptr->comm_list[ep_rank_loc]);
     (*newintercomm)->ep_comm_ptr->intercomm->intercomm_tag = local_comm->ep_comm_ptr->comm_label;
 
Index: /XIOS/dev/branch_openmp/extern/ep_dev/ep_lib.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/ep_dev/ep_lib.cpp	(revision 1511)
+++ /XIOS/dev/branch_openmp/extern/ep_dev/ep_lib.cpp	(revision 1512)
@@ -50,6 +50,6 @@
     for(int i=0; i<comm->ep_comm_ptr->intercomm->intercomm_rank_map->size(); i++)
     {
-      if(   ( comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(i).first  == ep_rank_loc )
-         && ( comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(i).second == mpi_rank ) )
+      if(   ( comm->ep_comm_ptr->intercomm->inter_rank_map->at(i).first  == ep_rank_loc )
+         && ( comm->ep_comm_ptr->intercomm->inter_rank_map->at(i).second == mpi_rank ) )
       {
         inter_rank =  i;
Index: /XIOS/dev/branch_openmp/extern/ep_dev/ep_send.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/ep_dev/ep_send.cpp	(revision 1511)
+++ /XIOS/dev/branch_openmp/extern/ep_dev/ep_send.cpp	(revision 1512)
@@ -240,6 +240,6 @@
       int inter_src = comm->ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).first;
       int ep_src_loc = comm->ep_rank_map->at(inter_src).first;
-      int ep_dest_loc = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).first;
-      int mpi_dest    = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).second;
+      int ep_dest_loc = comm->ep_comm_ptr->intercomm->inter_rank_map->at(dest_remote_ep_rank).first;
+      int mpi_dest    = comm->ep_comm_ptr->intercomm->inter_rank_map->at(dest_remote_ep_rank).second;
       int mpi_tag = tag_combine(tag, ep_src_loc, ep_dest_loc);
 
@@ -328,6 +328,6 @@
       int inter_src = comm->ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).first;
       int ep_src_loc = comm->ep_rank_map->at(inter_src).first;
-      int ep_dest_loc = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).first;
-      int mpi_dest    = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).second;
+      int ep_dest_loc = comm->ep_comm_ptr->intercomm->inter_rank_map->at(dest_remote_ep_rank).first;
+      int mpi_dest    = comm->ep_comm_ptr->intercomm->inter_rank_map->at(dest_remote_ep_rank).second;
       int mpi_tag = tag_combine(tag, ep_src_loc, ep_dest_loc);
 
Index: OS/dev/branch_openmp/extern/ep_dev/makefile
===================================================================
--- /XIOS/dev/branch_openmp/extern/ep_dev/makefile	(revision 1511)
+++ 	(revision )
@@ -1,27 +1,0 @@
-appname := EP_test
-
-CXX := mpiicc -D_intelmpi -D_noMemory_check -D_nocheck_sum -qopenmp
-CXXFLAGS := -std=c++11  -g
-
-srcfiles := $(shell find . -name "*.cpp")
-headfiles := $(shell find . -name "*.hpp")
-objects  := $(patsubst %.cpp, %.o, $(srcfiles))
-
-all: $(appname)
-
-$(appname): $(objects) $(headfiles)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $(appname) $(objects) $(LDLIBS)
-
-depend: .depend
-
-depend: $(srcfiles) 
-	rm -f ./.depend
-	$(CXX) $(CXXFLAGS) -MM $^>>./.depend;
-
-clean:
-	rm -f $(objects)
-
-dist-clean: clean
-	rm -f *~ .depend
-
-